import java.util.Scanner;
import org.antlr.runtime.tree.CommonTree;

class CosFunction implements InternalFunction {

	public DataType getDataType() {
		return DataType.FLOATING_POINT;
	}
	public String getName() {
		return "cos";
	}
	
	public ValueObject evaluate(DeltaInterpreter interpreter, CommonTree params) throws InterpreterException {		
		if (params.getChildCount()!=1) {
			throw new InterpreterException("Argument for 'sin' must be one");
		}
		ValueObject v = interpreter.evalExpr((CommonTree)params.getChild(0));
		switch (v.getType()) {
		case FLOATING_POINT:
			return new ValueObject(Math.cos(v.getFloatValue()));
		case INTEGER:
			return new ValueObject(Math.cos(v.getIntValue()));
		case VOID:
		case STRING:
			throw new InterpreterException("Argument for 'cos' must be int or float");
		}		
		return ValueObject.VOID_VALUE;
	}
}
