import java.util.Hashtable;
import org.antlr.runtime.tree.CommonTree;

class InternalFunctions {
	Hashtable<String, InternalFunction> functions =  new Hashtable<String, InternalFunction>();
	SymbolTable st;

	void addFunction(InternalFunction intfunc) {
		functions.put(intfunc.getName(), intfunc);
		st.put(intfunc.getName(), intfunc.getDataType(), SymbolTable.SymbolType.FUNCTION);
	}

	InternalFunctions(SymbolTable _st) {
		st = _st;
		addFunction(new PrintFunction());
		addFunction(new PrintLnFunction());
		addFunction(new InputFunction());
		addFunction(new SinFunction());
		addFunction(new CosFunction());
	}

	ValueObject evaluate(DeltaInterpreter interpreter, CommonTree expr) throws InterpreterException{
		CommonTree function = (CommonTree)expr.getChild(0);
		String fname = function.getText();
		CommonTree params = (CommonTree)expr.getChild(1);
		return functions.get(fname).evaluate(interpreter, params);
	}
}
